/* GENERATED, DO NOT EDIT! See http://gltk.ccdw.org/ for source. */
/* gltk_Q5B.cc: adjustment bin box button checkbox checkbutton container entry focusable glarea glutwindow idle label labelbin main pushbox scale shape spinbutton timeout widget window
 *
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This file was generated from gltk.
 *
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with arg.  If not, see <http://www.gnu.org/licenses/>.
 * 
 */
#include "gltk_Q5B.hh"
#include <algorithm>
#include <cassert>
#include <cctype>
#include <cmath>
#include <iomanip>
#include <sstream>
using namespace gltk;
namespace gltk {
	int glut_get_font_height(void * font);
	int glut_get_font_ascent(void * font);
	int glut_get_font_descent(void * font);
	void glut_draw_string(void * font, std::string const & text);
	void glut_draw_string(void * font, std::string const & text, int limit);
	int glut_get_string_width(void * font, std::string const & text);
	void glut_draw_raised_box(int x, int y, int w, int h);
	int glut_raised_box_width();
	void glut_draw_sunken_box(int x, int y, int w, int h);
	int glut_sunken_box_width();
	inline int round_int(double x) {return x > 0 ? int(x + 0.5) : int(x - 0.5);}
	template<typename T>
	inline T min_of(T a, T b) {return a > b ? b : a;}
	template<typename T>
	inline T max_of(T a, T b) {return a > b ? a : b;}
	struct Error
	{
		std::string msg;
		Error(std::string const & s) : msg(s) {}
	};
}
Adjustment::Adjustment() :
	value(0.0),
	lower(0),
	upper(1),
	step_increment(0.01),
	page_increment(0.1),
	page_size(0.1)
{
	assert(value == 0);
}
Adjustment::Adjustment(double val, double lo, double up, double st, double pg, double psz) :
	value(val),
	lower(lo),
	upper(up),
	step_increment(st),
	page_increment(pg),
	page_size(psz)
{}
void Adjustment::configure(double val, double lo, double up, double st, double pg, double ps)
{
	lower = lo;
	upper = up;
	step_increment = st;
	page_increment = pg;
	page_size = ps;
	if (value != val) {
		value = val;
		on_value_changed();
		value_changed.emit();
	}
}
double Adjustment::get_value() const
{
	return value;
}
void Adjustment::set_value(double v)
{
	if (v > upper) v = upper;
	if (v < lower) v = lower;
	if (v != value) {
		value = v;
		on_value_changed();
		value_changed.emit();
	}
}
void Adjustment::step_up()
{
	set_value(value + step_increment);
}
void Adjustment::step_down()
{
	set_value(value - step_increment);
}
void Adjustment::page_up()
{
	set_value(value + page_increment);
}
void Adjustment::page_down()
{
	set_value(value - page_increment);
}
void Adjustment::set_step_increment(double inc)
{
	step_increment = inc;
}
void Adjustment::set_page_increment(double inc)
{
	page_increment = inc;
}
void Adjustment::set_upper(double v)
{
	upper = v;
	if (value > upper) set_value(upper);
}
void Adjustment::set_lower(double v)
{
	lower = v;
	if (value < lower) set_value(lower);
}
sigc::signal<void> & Adjustment::signal_value_changed()
{
	return value_changed;
}
void Bin::on_configure_event()
{
	if (! child) return;
	int width = get_width();
	int height = get_height();
	if (width < reserved_x && height < reserved_y) {
		child->size_allocate(0, 0, 0, 0);
		return;
	}
	width -= reserved_x;
	height -= reserved_y;
	int m;
	int n;
	child->get_preferred_width(m, n);
	int w = min_of(width, max_of(n, width - reducible_x));
	child->get_preferred_height_for_width(w, m, n);
	int h = min_of(height, max_of(n, height - reducible_y));
	child_x = (width - w) / 2;
	child_y = (height - h) / 2;
	child->size_allocate(child_x, child_y, w, h);
}
void Bin::get_preferred_width(int & min, int & nat) const
{
	min = reserved_x;
	nat = reserved_x + reducible_x;
	if (child) {
		int m;
		int n;
		child->get_preferred_width(m, n);
		min += m;
		nat += n;
	}
}
void Bin::get_preferred_height(int & min, int & nat) const
{
	min = reserved_y;
	nat = reserved_y + reducible_y;
	if (child) {
		int m;
		int n;
		child->get_preferred_height(m, n);
		min += m;
		nat += n;
	}
}
void Bin::get_preferred_width_for_height(int height, int & min, int & nat) const
{
	min = reserved_x;
	nat = reserved_x + reducible_x;
	if (child) {
		int m;
		int n;
		child->get_preferred_height(m, n);
		int child_h = max_of(0, height - reserved_y);
		if (child_h > n) child_h = max_of(n, n - reducible_y);
		child->get_preferred_width_for_height(child_h, m, n);
		min += m;
		nat += n;
	}
}
void Bin::get_preferred_height_for_width(int width, int & min, int & nat) const
{
	min = reserved_y;
	nat = reserved_y + reducible_y;
	if (child) {
		int m;
		int n;
		child->get_preferred_width(m, n);
		int child_w = max_of(0, width - reserved_x);
		if (child_w > n) child_w = max_of(n, n - reducible_x);
		child->get_preferred_height_for_width(child_w, m, n);
		min += m;
		nat += n;
	}
}
void Bin::on_add(Widget * w)
{
	if (child) throw Error("add to Bin with a child");
	child = w;
}
void Bin::on_remove(Widget * w)
{
	if (child != w) throw Error("removed child not in Bin");
	child = 0;
}
Bin::Bin() :
	child(0),
	reducible_x(0),
	reducible_y(0),
	reserved_x(0),
	reserved_y(0)
{}
void Bin::set_reducible(int red_x, int red_y)
{
	reducible_x = red_x;
	reducible_y = red_y;
}
void Bin::set_reserved(int x, int y)
{
	reserved_x = x;
	reserved_y = y;
}
void Bin::place_bin(int x, int y)
{
	if (child) child->move_allocate(child_x + x, child_y + y);
}
void Bin::set_border_width(unsigned w)
{
	set_reducible(w * 2, w * 2);
}
void Box::on_configure_event()
{
	int width = get_width();
	int height = get_height();
	if (orientation == HORIZONTAL) {
		int min = 0;
		int nat = 0;
		std::vector<Widget *>::const_iterator e = child_list.end();
		int cnt = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			int m;
			int n;
			(* i)->get_preferred_width_for_height(width, m, n);
			min += m;
			nat += n;
			if (min > width) {
				min -= m;
				nat -= n;
				e = i;
				break;
			}
			cnt ++;
		}
		int pad = width > nat && cnt > 1 ? (width - nat) / (cnt - 1) : 0;
		int ext = width - min - (cnt - 1) * pad;
		int x = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			(* i)->get_preferred_width_for_height(height, min, nat);
			int w = min_of(nat, min + ext);
			(* i)->size_allocate(x, 0, w, height);
			x += w + pad;
			ext -= (w - min);
		}
		while (e != child_list.end()) {
			(* e)->size_allocate(width, 0, 0, height);
			e ++;
		}
	}
	else {
		int min = 0;
		int nat = 0;
		std::vector<Widget *>::const_iterator e = child_list.end();
		int cnt = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			int m;
			int n;
			(* i)->get_preferred_height_for_width(width, m, n);
			min += m;
			nat += n;
			if (min > height) {
				min -= m;
				nat -= n;
				e = i;
				break;
			}
			cnt ++;
		}
		int pad = height > nat && cnt > 1 ? (height - nat) / (cnt - 1) : 0;
		int ext = height - min - (cnt - 1) * pad;
		int y = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			(* i)->get_preferred_height_for_width(width, min, nat);
			int h = min_of(nat, min + ext);
			(* i)->size_allocate(0, y, width, h);
			y += h + pad;
			ext -= (h - min);
		}
		while (e != child_list.end()) {
			(* e)->size_allocate(0, height, width, 0);
			e ++;
		}
	}
}
void Box::get_preferred_width(int & min, int & nat) const
{
	min = 0;
	nat = 0;
	if (orientation == HORIZONTAL) {
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != child_list.end(); i ++) {
			int m;
			int n;
			(* i)->get_preferred_width(m, n);
			min += m;
			nat += n;
		}
	}
	else {
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != child_list.end(); i ++) {
			int m;
			int n;
			(* i)->get_preferred_width(m, n);
			min = max_of(min, m);
			nat = max_of(nat, n);
		}
	}
	nat += border_width;
}
void Box::get_preferred_height(int & min, int & nat) const
{
	min = 0;
	nat = 0;
	if (orientation == HORIZONTAL) {
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != child_list.end(); i ++) {
			int m;
			int n;
			(* i)->get_preferred_height(m, n);
			min = max_of(min, m);
			nat = max_of(nat, n);
		}
	}
	else {
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != child_list.end(); i ++) {
			int m;
			int n;
			(* i)->get_preferred_height(m, n);
			min += m;
			nat += n;
		}
	}
	nat += border_width;
}
void Box::get_preferred_width_for_height(int height, int & min, int & nat) const
{
	min = 0;
	nat = 0;
	if (orientation == HORIZONTAL) {
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != child_list.end(); i ++) {
			int m;
			int n;
			(* i)->get_preferred_width_for_height(height, m, n);
			min += m;
			nat += n;
		}
	}
	else {
		std::vector<Widget *>::const_iterator e = child_list.end();
		int cnt = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			int m;
			int n;
			(* i)->get_preferred_height(m, n);
			min += m;
			nat += n;
			if (min > height) {
				min -= m;
				nat -= n;
				e = i;
				break;
			}
			cnt ++;
		}
		int ext = height - min;
		min = 0;
		nat = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			int mh;
			int nh;
			(* i)->get_preferred_height(mh, nh);
			int h = min_of(nh, mh + ext);
			int mw;
			int nw;
			(* i)->get_preferred_width_for_height(h, mw, nw);
			ext -= (h - mh);
			min = max_of(min, mw);
			nat = max_of(nat, nw);
		}
	}
	nat += border_width;
}
void Box::get_preferred_height_for_width(int width, int & min, int & nat) const
{
	if (orientation == HORIZONTAL) {
		min = 0;
		nat = 0;
		std::vector<Widget *>::const_iterator e = child_list.end();
		int cnt = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			int m;
			int n;
			(* i)->get_preferred_width(m, n);
			min += m;
			nat += n;
			if (min > width) {
				min -= m;
				nat -= n;
				e = i;
				break;
			}
			cnt ++;
		}
		int ext = width - min;
		min = 0;
		nat = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != e; i ++) {
			int mw;
			int nw;
			(* i)->get_preferred_width(mw, nw);
			int w = min_of(nw, mw + ext);
			int mh;
			int nh;
			(* i)->get_preferred_height_for_width(w, mh, nh);
			ext -= (w - mw);
			min = max_of(min, mh);
			nat = max_of(nat, nh);
		}
	}
	else {
		min = 0;
		nat = 0;
		for (std::vector<Widget *>::const_iterator i = child_list.begin(); i != child_list.end(); i ++) {
			int m;
			int n;
			(* i)->get_preferred_height_for_width(width, m, n);
			min += m;
			nat += n;
		}
	}
}
Box::Box(Orientation ori, int sp) :
	orientation(ori),
	border_width(0),
	spacing(sp)
{}
void Box::pack_start(Widget * child)
{
	add(child);
}
void Box::set_border_width(unsigned bw)
{
	border_width = bw;
}
void Button::on_draw()
{
	PushBox::draw_box();
	if (child) {
		int d = box_width + depressed;
		place_bin(d, d);
		draw_children();
	}
}
void Button::get_preferred_height(int & min, int & nat) const
{
	Bin::get_preferred_height(min, nat);
}
void Button::get_preferred_width(int & min, int & nat) const
{
	Bin::get_preferred_width(min, nat);
}
void Button::get_preferred_width_for_height(int height, int & min, int & nat) const
{
	Bin::get_preferred_width_for_height(height, min, nat);
}
void Button::get_preferred_height_for_width(int width, int & min, int & nat) const
{
	Bin::get_preferred_height_for_width(width, min, nat);
}
bool Button::focus_make()
{
	return PushBox::focus_make();
}
bool Button::focus_next()
{
	return PushBox::focus_next();
}
void Button::focus_end()
{
	PushBox::focus_end();
}
void Button::on_button_event(int button, int state, int x, int y)
{
	PushBox::on_button_event(button, state, x, y);
}
bool Button::on_key_event(unsigned char key)
{
	return PushBox::on_key_event(key);
}
Button::Button(std::string const & name) :
	LabelBin(name)
{
	int rs = box_width * 2 + 1;
	set_reserved(rs, rs);
}
Button::Button(Widget * w) :
	LabelBin(w)
{
	int rs = box_width * 2 + 1;
	set_reserved(rs, rs);
}
const int CheckBox::checkbox_size = 7;
const int CheckBox::checkbox_area = 20;
void CheckBox::on_draw()
{
	draw_focus_box();
	draw_checkbox(0, 0, get_width(), get_height());
}
void CheckBox::get_preferred_width(int & min, int & nat) const
{
	min = checkbox_size;
	nat = checkbox_area;
}
void CheckBox::get_preferred_height(int & min, int & nat) const
{
	min = checkbox_size;
	nat = checkbox_area;
}
void CheckBox::on_button_event(int button, int state, int x, int y)
{
	if (button != GLUT_LEFT_BUTTON) return;
	if (state == GLUT_DOWN) {
		active = ! active;
		toggled.emit();
	}
	if (get_realized()) glutPostRedisplay();
}
bool CheckBox::on_key_event(unsigned char key)
{
	if (key == 0xd || key == 0x20) {
		active = ! active;
		toggled.emit();
		glutPostRedisplay();
		return true;
	}
	return false;
}
void CheckBox::draw_checkbox(int x, int y, int w, int h)
{
	int checkbox_size = 7;
	if (w > checkbox_size && h > checkbox_size) {
		float dx = (w - checkbox_size) / 2 - 0.5;
		float dy = (h - checkbox_size) / 2 - 0.5;
		glColor3ub(0, 0, 0);
		glBegin(GL_LINE_LOOP);
		glVertex2f(dx, dy);
		glVertex2f(dx + checkbox_size, dy);
		glVertex2f(dx + checkbox_size, dy + checkbox_size);
		glVertex2f(dx, dy + checkbox_size);
		glEnd();
		if (active) {
			glColor3ub(0, 0, 0);
			glBegin(GL_LINES);
			glVertex2f(dx, dy);
			glVertex2f(dx + checkbox_size, dy + checkbox_size);
			glVertex2f(dx + checkbox_size, dy);
			glVertex2f(dx, dy + checkbox_size);
			glEnd();
		}
	}
}
CheckBox::CheckBox() :
	active(false)
{
}
sigc::signal<void> & CheckBox::signal_toggled()
{
	return toggled;
}
bool CheckBox::get_active() const
{
	return active;
}
void CheckBox::set_active(bool val)
{
	active = val;
}
void CheckButton::on_configure_event()
{
	Bin::on_configure_event();
	if (child) {
		int ch = child->get_height();
		child->move_allocate(min_of(checkbox_area, get_width()), (get_height() - ch) / 2);
	}
}
void CheckButton::on_draw()
{
	int w = get_width();
	int h = get_height();
	draw_focus_box();
	w = min_of(w, checkbox_area);
	draw_checkbox(0, 0, w, h);
	draw_children();
}
void CheckButton::get_preferred_width(int & min, int & nat) const
{
	Bin::get_preferred_width(min, nat);
	min = checkbox_size;
}
void CheckButton::get_preferred_height(int & min, int & nat) const
{
	Bin::get_preferred_height(min, nat);
	min = checkbox_size;
	nat = max_of(nat, checkbox_area);
}
void CheckButton::get_preferred_width_for_height(int height, int & min, int & nat) const
{
	Bin::get_preferred_width_for_height(height, min, nat);
	min = checkbox_size;
}
void CheckButton::get_preferred_height_for_width(int width, int & min, int & nat) const
{
	Bin::get_preferred_height_for_width(width, min, nat);
	min = checkbox_size;
	nat = max_of(nat, checkbox_area);
}
void CheckButton::on_button_event(int button, int state, int x, int y)
{
	CheckBox::on_button_event(button, state, x, y);
}
bool CheckButton::on_key_event(unsigned char key)
{
	return CheckBox::on_key_event(key);
}
bool CheckButton::focus_make()
{
	return CheckBox::focus_make();
}
bool CheckButton::focus_next()
{
	return CheckBox::focus_next();
}
void CheckButton::focus_end()
{
	CheckBox::focus_end();
}
CheckButton::CheckButton(std::string const & label) :
	LabelBin(label)
{
	set_reserved(checkbox_area + 1, 2);
}
void Container::on_realize(int win)
{
	realize_children(win);
}
void Container::on_unrealize()
{
	unrealize_children();
}
void Container::on_draw()
{
	draw_children();
}
void Container::on_button_event(int button, int state, int x, int y)
{
	if (grabber) grabber->button_event(button, state, x, y);
	else if (Widget * w = get_child(x, y)) {
		w->button_event(button, state, x, y);
	}
	if (! grabber) on_passive_event(x, y);
}
void Container::on_motion_event(int x, int y)
{
	if (grabber) grabber->motion_event(x, y);
	else on_passive_event(x, y);
}
void Container::on_passive_event(int x, int y)
{
	if (Widget * w = get_child(x, y)) {
		if (tracker != w) {
			if (tracker) tracker->entry_event(false);
			tracker = w;
			w->entry_event(true);
		}
		w->passive_event(x, y);
	}
	else if (tracker) {
		tracker->entry_event(false);
		tracker = 0;
	}
}
bool Container::on_key_event(unsigned char key)
{
	if (focus) return focus->keyboard_event(key);
	return false;
}
bool Container::on_special_event(int key)
{
	if (focus) return focus->special_event(key);
	return false;
}
void Container::on_entry_event(bool entered)
{
	if ((! entered) && tracker) {
		tracker->entry_event(false);
		tracker = 0;
	}
}
bool Container::focus_make()
{
	if (focus) {
		if (focus->focus_make()) return true;
		focus = 0;
	}
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) if ((* i)->focus_make()) {
		focus = * i;
		return true;
	}
	return false;
}
bool Container::focus_next()
{
	std::vector<Widget *>::iterator i = child_list.begin();
	if (focus) {
		if (focus->focus_next()) return true;
		do if (i == child_list.end()) {
			focus = 0;
			return false;
		} while (focus != * (i ++));
	}
	while (i != child_list.end()) {
		if ((* i)->focus_make()) {
			focus = * i;
			return true;
		}
		i ++;
	}
	focus = 0;
	return false;
}
void Container::focus_end()
{
	if (focus) focus->focus_end();
}
Widget * Container::get_child(int x, int y)
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) {
		if ((* i)->contains(x, y)) return * i;
	}
	return 0;
}
void Container::draw_children()
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) {
		glPushMatrix();
		(* i)->draw();
		glPopMatrix();
	}
}
void Container::realize_children(int win)
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) {
		(* i)->realize(win);
	}
}
void Container::unrealize_children()
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) {
		(* i)->unrealize();
	}
}
Container::Container() :
	grabber(0),
	focus(0),
	tracker(0)
{}
Container::~Container()
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) {
		if ((* i)->get_managed()) delete * i;
	}
}
void Container::add(Widget * child)
{
	child_list.push_back(child);
	child->set_parent(this);
	on_add(child);
	if (get_realized()) child->realize(get_realized());
}
void Container::remove(Widget * child)
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++)
	if (* i == child) {
		child_list.erase(i);
		if (get_realized()) child->unrealize();
		on_remove(child);
		child->set_parent(0);
		return;
	}
	throw Error("child not found");
}
void Container::show_all()
{
	show();
	show_all_children(true);
}
void Container::show_all_children(bool recursive)
{
	for (std::vector<Widget *>::iterator i = child_list.begin(); i != child_list.end(); i ++) {
		Container * c = dynamic_cast<Container *>(* i);
		if (recursive && c) c->show_all();
		else (* i)->show();
	}
}
void Container::set_grabber(Widget * child, bool grab)
{
	if (grabber) {
		if (grab) throw("already grabbed!");
		if (grabber != child) throw("child not the grabber!");
		grabber = 0;
		set_grabbing(false);
		return;
	}
	grabber = child;
	set_grabbing(true);
}
bool Container::focus_on(Widget * child)
{
	if (! get_focus()) return false;
	if (focus && focus != child) focus->focus_end();
	focus = child;
	return true;
}
void Entry::on_draw()
{
	int w = get_width();
	int h = get_height();
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_QUADS);
	glVertex2i(0, 0);
	glVertex2i(w, 0);
	glVertex2i(w, h);
	glVertex2i(0, h);
	glEnd();
	glut_draw_sunken_box(0, 0, w, h);
	int cx = - 1;
	int ex = (h - glut_get_font_height(font)) / 2;
	if (marked) {
		if (cx < 0) cx = find_x(cursor);
		int mx = find_x(mark);
		glColor3f(0.8, 0.8, 1.0);
		glBegin(GL_QUADS);
		glVertex2i(mx, ex);
		glVertex2i(cx, ex);
		glVertex2i(cx, ex + glut_get_font_height(font));
		glVertex2i(mx, ex + glut_get_font_height(font));
		glEnd();
	}
	if (vstart) {
		glColor3f(0.5, 0.25, 0.25);
		glBegin(GL_TRIANGLES);
		glVertex2f(bw + as - 1, ex);
		glVertex2f(bw + as - 1, ex + glut_get_font_height(font));
		glVertex2f(bw - 1, h / 2.0);
		glEnd();
	}
	if (visibility) glColor3f(0, 0, 0);
	else glColor3f(1.0, 0.4, 0.4);
	int xs = vstart ? bw + as : bw;
	int mx = w - bw;
	glRasterPos2i(xs, ex + glut_get_font_ascent(font));
	bool check = false;
	end_arrow = false;
	for (size_t i = vstart; i < text.size(); i ++) {
		char c = visibility ? text[i] : '*';
		xs += glutBitmapWidth(font, c);
		if (xs > mx - as && ! check) {
			size_t j = i;
			int xss = xs;
			check = true;
			do {
				if (xss > mx) {
					glColor3f(0.5, 0.25, 0.25);
					glBegin(GL_TRIANGLES);
					glVertex2f(w - bw - as + 1, ex);
					glVertex2f(w - bw - as + 1, ex + glut_get_font_height(font));
					glVertex2f(w - bw + 1, h / 2.0);
					glEnd();
					end_arrow = true;
					break;
				}
				if (++ j > text.size()) break;
				xss += glutBitmapWidth(font, visibility ? text[j] : '*');
			} while (true);
			if (end_arrow) break;
		}
		glutBitmapCharacter(font, c);
	}
	if (focused) {
		if (cx < 0) cx = find_x(cursor);
		glBegin(GL_LINES);
		if (editable) glColor3f(0, 0, 1.0);
		else glColor3f(0.6, 0.6, 0.0);
		glVertex2f(0.5 + cx, ex);
		glVertex2f(0.5 + cx, ex + glut_get_font_height(font));
		glEnd();
	}
}
void Entry::on_button_event(int button, int state, int x, int y)
{
	if (! focused) {
		if (get_focus()) {
			focused = true;
			glutPostRedisplay();
		}
	}
	if (button != GLUT_LEFT_BUTTON) return;
	if (state == GLUT_DOWN) {
		set_grabbing();
		cursor = find_position(x);
		marked = true;
		mark = cursor;
	}
	else {
		set_grabbing(false);
	}
	if (get_realized()) glutPostRedisplay();
}
void Entry::on_motion_event(int x, int y)
{
	if (! marked) return;
	if (x < 0 || x > get_width() - bw - 2) return;
	size_t p = find_position(x);
	if (p != cursor) {
		cursor = p;
		glutPostRedisplay();
	}
}
bool Entry::on_key_event(unsigned char key)
{
	if (isprint(key)) {
		if (editable) {
			if (marked) delete_marked();
			text.insert(cursor, 1, char(key));
			cursor ++;
			adjust_vstart();
		}
		marked = false;
	}
	else switch (key) {
	case 0x8:
		if (editable) {
			if (marked) delete_marked();
			else if (cursor > 0) {
				cursor --;
				if (vstart > cursor) vstart = cursor;
				text.erase(cursor, 1);
			}
		}
		break;
	case 0xb:
		if (editable) {
			if (marked) delete_marked();
			else if (cursor < text.size()) text.erase(cursor);
		}
		break;
	case 0xd:
		activate.emit();
		select_all();
		return true;
	case 0x7f:
		if (editable) {
			if (marked) delete_marked();
			else if (cursor < text.size()) text.erase(cursor, 1);
		}
		break;
	default:
		return false;
	}
	marked = false;
	if (get_realized()) glutPostRedisplay();
	return true;
}
bool Entry::on_special_event(int key)
{
	if (! marked && glutGetModifiers() == GLUT_ACTIVE_SHIFT) {
		mark = cursor;
		marked = true;
	}
	switch (key) {
	case GLUT_KEY_LEFT:
		if (cursor > 0) {
			cursor --;
			if (vstart > cursor) vstart = cursor;
		}
		break;
	case GLUT_KEY_RIGHT:
		if (cursor < text.size()) {
			cursor ++;
			adjust_vstart();
		}
		break;
	case GLUT_KEY_HOME:
		vstart = 0;
		cursor = 0;
		break;
	case GLUT_KEY_END:
		cursor = text.size();
		adjust_vstart();
		break;
	default:
		return false;
	}
	if (glutGetModifiers() != GLUT_ACTIVE_SHIFT) marked = false;
	if (get_realized()) glutPostRedisplay();
	return true;
}
bool Entry::focus_make()
{
	focused = true;
	select_all();
	return true;
}
void Entry::focus_end()
{
	if (focused) {
		focused = false;
		stop.emit();
		select_none();
		glutPostRedisplay();
	}
}
void Entry::adjust_vstart()
{
	int aw = get_width() - bw * 2;
	if (visibility)	{
		int w = 0;
		for (size_t i = vstart; i < cursor; i ++) w += glutBitmapWidth(font, text[i]);
		int ce = 0;
		for (size_t j = cursor; j < text.size() && ce <= as; j ++) {
			ce += glutBitmapWidth(font, text[j]);
		}
		if (vstart) w += as;
		while (w > aw - as && w + ce > aw) {
			w -= glutBitmapWidth(font, text[vstart]);
			if (! vstart) w += as;
			vstart ++;
		}
	}
	else {
		int w = glutBitmapWidth(font, '*') * (cursor - vstart);
		if ((vstart ? w + as : w) > aw) {
			vstart = cursor - (aw - as) / glutBitmapWidth(font, '*');
			if (vstart < 0) vstart = 0;
		}
	}
}
int Entry::find_x(size_t p)
{
	int x = vstart ? bw + as : bw;
	if (p <= vstart) return x;
	if (p > text.size()) p = text.size();
	if (visibility) for (size_t i = vstart; i < p; i ++) x += glutBitmapWidth(font, text[i]);
	else x += glutBitmapWidth(font, '*') * (p - vstart);
	return min_of(x, get_width() - bw);
}
size_t Entry::find_position(int x)
{
	int w = vstart ? bw + as : bw;
	int mx = get_width() - (end_arrow ? bw + as : bw);
	for (size_t i = vstart; i < text.size(); i ++) {
		int cw = glutBitmapWidth(font, text[i]);
		if (w + cw / 2 > x) return i;
		w += cw;
		if (w > mx) return i;
	}
	return text.size();
}
void Entry::delete_marked()
{
	if (mark < cursor) {
		text.erase(mark, cursor - mark);
		cursor = mark;
		if (vstart > cursor) vstart = cursor;
	}
	else text.erase(cursor, mark - cursor);
	marked = false;
}
Entry::Entry() :
	focused(false),
	editable(true),
	visibility(true),
	cursor(0),
	vstart(0),
	marked(false),
	font(GLUT_BITMAP_HELVETICA_12),
	width_chars(0)
{
	bw = glut_sunken_box_width() + 1;
	as = 5;
	end_arrow = false;
}
void Entry::get_preferred_height(int & min, int & nat) const
{
	int h = glut_get_font_height(font);
	min = h + bw * 2;
	nat = h + bw * 2 + 4;
}
void Entry::get_preferred_width(int & min, int & nat) const
{
	if (width_chars) {
		nat = width_chars * glutBitmapWidth(font, 'W') + bw * 2;
		min = nat;
	}
	else {
		min = 10 + bw * 2;
		nat = 100 + bw * 2;
	}
}
void Entry::set_text(std::string const & t)
{
	text = t;
	if (cursor > t.size()) {
		cursor = t.size();
		if (vstart > cursor) vstart = cursor;
	}
	if (marked && mark > t.size()) mark = t.size();
	if(get_realized()) glutPostRedisplay();
}
std::string const & Entry::get_text() const
{
	return text;
}
size_t Entry::get_text_length() const
{
	return text.size();
}
void Entry::select_all()
{
	mark = text.size();
	marked = true;
	cursor = 0;
	vstart = 0;
	if (get_realized()) glutPostRedisplay();
}
void Entry::select_none()
{
	marked = false;
	cursor = 0;
	vstart = 0;
	if (get_realized()) glutPostRedisplay();
}
void Entry::set_max_length(size_t length)
{
	max_length = length;
}
void Entry::set_width_chars(int n_chars)
{
	width_chars = n_chars;
}
void Entry::set_editable(bool v)
{
	editable = v;
}
void Entry::set_visibility(bool v)
{
	if (v != visibility) {
		visibility = v;
		if (get_realized()) adjust_vstart();
	}
}
sigc::signal<void> & Entry::signal_activate()
{
	return activate;
}
sigc::signal<void> & Entry::signal_stop()
{
	return stop;
}
bool Focusable::focus_make()
{
	focused = true;
	if (get_realized()) glutPostRedisplay();
	return true;
}
bool Focusable::focus_next()
{
	focus_end();
	return false;
}
void Focusable::focus_end()
{
	focused = false;
	if (get_realized()) glutPostRedisplay();
}
void Focusable::draw_focus_box()
{
	if (focused) {
		int w = get_width();
		int h = get_height();
		glEnable(GL_LINE_STIPPLE);
		glLineStipple(1, 0x5555);
		glColor3f(0., 0., 0.);
		glBegin(GL_LINE_LOOP);
		glVertex2f(0.5, 0.5);
		glVertex2f(w - 0.5, 0.5);
		glVertex2f(w - 0.5, h - 0.5);
		glVertex2f(0.5, h - 0.5);
		glEnd();
		glDisable(GL_LINE_STIPPLE);
	}
}
Focusable::Focusable() :
	focused(false)
{}
void glArea::on_display_func()
{
	assert(glutGetWindow() == get_win_id());
	gl_draw();
	glutSwapBuffers();
}
void glArea::on_reshape_func(int width, int height)
{
	gl_new_size(width, height);
}
void glArea::on_draw()
{
	if (int wid = get_win_id()) {
		int oid = glutGetWindow();
		glutSetWindow(wid);
		glutPostRedisplay();
		glutSetWindow(oid);
	}
}
void glArea::on_unrealize()
{
	if (get_win_id()) destroy();
}
void glArea::on_configure_event()
{
	if (! get_shown()) return;
	Allocation a = get_allocation();
	if (int wid = get_win_id()) {
		glutSetWindow(wid);
		glutReshapeWindow(a.width, a.height);
		glutPositionWindow(a.x, a.y);
	}
	else {
		int pwin = get_realized();
		assert(pwin);
		create(pwin, a.x, a.y, a.width, a.height);
		gl_setup();
	}
}
void glArea::on_show()
{
	if (int pwin = get_realized()) {
		if (int wid = get_win_id()) {
			glutSetWindow(wid);
			glutShowWindow();
		}
		else {
			Allocation a = get_allocation();
			create(pwin, a.x, a.y, a.width, a.height);
			gl_setup();
		}
	}
}
void glArea::on_hide()
{
	if (int wid = get_win_id()) {
		glutSetWindow(wid);
		glutHideWindow();
	}
}
void glArea::get_preferred_height(int & min, int & nat) const
{
	min = 0;
	nat = area_height;
}
void glArea::get_preferred_width(int & min, int & nat) const
{
	min = 0;
	nat = area_width;
}
glArea::glArea() :
	area_width(200),
	area_height(200)
{
	set_events(DISPLAY_MASK | RESHAPE_MASK | MOUSE_MASK | MOTION_MASK);
}
glArea::~glArea()
{
	if (get_win_id()) destroy();
}
void glArea::set_size(int width, int height)
{
	area_width = width;
	area_height = height;
}
namespace gltk {
	class _glutWindow
	{
		static std::map<int, glutWindow *> win_list;
		typedef void (* cb_setter)(glutWindow *, bool);
		static cb_setter cb_set_list[];
		static void display_func();
		static void reshape_func(int width, int height);
		static void mouse_func(int button, int state, int x, int y);
		static void motion_func(int x, int y);
		static void passive_func(int x, int y);
		static void keyboard_func(unsigned char key, int x, int y);
		static void special_func(int key, int x, int y);
		static void entry_func(int state);
	public:
		static void create(glutWindow * w, int parent, int x, int y, int width, int height);
		static void create(glutWindow * w, std::string const & name, int width, int height);
		static void destroy(glutWindow * w);
		static void destroy_all();
		static void cb_set_display(glutWindow *, bool);
		static void cb_set_reshape(glutWindow *, bool);
		static void cb_set_mouse(glutWindow *, bool);
		static void cb_set_motion(glutWindow *, bool);
		static void cb_set_passive(glutWindow *, bool);
		static void cb_set_keyboard(glutWindow *, bool);
		static void cb_set_special(glutWindow *, bool);
		static void cb_set_entry(glutWindow *, bool);
		static void setup_cb(glutWindow * g, unsigned origin = 0);
	};
}
std::map<int, glutWindow *> _glutWindow::win_list;
_glutWindow::cb_setter _glutWindow::cb_set_list[] = {
	& _glutWindow::cb_set_display,
	& _glutWindow::cb_set_reshape,
	& _glutWindow::cb_set_mouse,
	& _glutWindow::cb_set_motion,
	& _glutWindow::cb_set_passive,
	& _glutWindow::cb_set_keyboard,
	& _glutWindow::cb_set_special,
	& _glutWindow::cb_set_entry
};
void _glutWindow::display_func()
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_display_func();
}
void _glutWindow::reshape_func(int width, int height)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_reshape_func(width, height);
}
void _glutWindow::mouse_func(int button, int state, int x, int y)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_mouse_func(button, state, x, y);
}
void _glutWindow::motion_func(int x, int y)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_motion_func(x, y);
}
void _glutWindow::passive_func(int x, int y)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_passive_func(x, y);
}
void _glutWindow::keyboard_func(unsigned char key, int x, int y)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_keyboard_func(key, x, y);
}
void _glutWindow::special_func(int key, int x, int y)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_special_func(key, x, y);
}
void _glutWindow::entry_func(int state)
{
	glutWindow & w = * win_list[glutGetWindow()];
	w.on_entry_func(state);
}
void _glutWindow::create(glutWindow * g, int p, int x, int y, int w, int h)
{
	assert(! g->win_id);
	if (p) {
		g->win_id = glutCreateSubWindow(p, x, y, w, h);
	}
	else {
		glutInitWindowSize(w, h);
		glutInitWindowPosition(x, y);
		g->win_id = glutCreateWindow("gltk Window");
	}
	win_list[g->win_id] = g;
	g->on_create();
}
void _glutWindow::create(glutWindow * g, std::string const & name, int w, int h)
{
	glutInitWindowSize(w, h);
	g->win_id = glutCreateWindow(name.c_str());
	g->on_create();
	win_list[g->win_id] = g;
}
void _glutWindow::destroy(glutWindow * g)
{
	win_list.erase(g->win_id);
	g->on_destroy();
	glutDestroyWindow(g->win_id);
	g->win_id = 0;
}
void _glutWindow::cb_set_display(glutWindow * g, bool v)
{
	if (v) glutDisplayFunc(& display_func);
	else glutDisplayFunc(0);
}
void _glutWindow::cb_set_reshape(glutWindow * g, bool v)
{
	if (v) glutReshapeFunc(& reshape_func);
	else glutReshapeFunc(0);
}
void _glutWindow::cb_set_mouse(glutWindow * g, bool v)
{
	if (v) glutMouseFunc(& mouse_func);
	else glutMouseFunc(0);
}
void _glutWindow::cb_set_motion(glutWindow * g, bool v)
{
	if (v) glutMotionFunc(& motion_func);
	else glutMotionFunc(0);
}
void _glutWindow::cb_set_passive(glutWindow * g, bool v)
{
	if (v) glutPassiveMotionFunc(& passive_func);
	else glutPassiveMotionFunc(0);
}
void _glutWindow::cb_set_keyboard(glutWindow * g, bool v)
{
	if (v) glutKeyboardFunc(& keyboard_func);
	else glutKeyboardFunc(0);
}
void _glutWindow::cb_set_special(glutWindow * g, bool v)
{
	if (v) glutSpecialFunc(& special_func);
	else glutSpecialFunc(0);
}
void _glutWindow::cb_set_entry(glutWindow * g, bool v)
{
	if (v) glutEntryFunc(& entry_func);
	else glutEntryFunc(0);
}
void _glutWindow::setup_cb(glutWindow * g, unsigned origin)
{
	for (size_t i = 0; i < 8; i ++) {
		unsigned mask = 1 << i;
		bool f0 = origin & mask;
		bool f1 = g->event_mask & mask;
		if (f1 != f0) (* cb_set_list[i])(g, f1);
	}
}
glutWindow::glutWindow() :
	win_id(0),
	event_mask(EVENT_MASK_NONE)
{
}
glutWindow::~glutWindow()
{
}
void glutWindow::set_events(unsigned mask)
{
	if (win_id) {
		unsigned om = event_mask;
		event_mask = mask;
		_glutWindow::setup_cb(this, om);
	}
	else event_mask = mask;
}
void glutWindow::add_events(unsigned mask)
{
	if (win_id) {
		unsigned om = event_mask;
		event_mask |= mask;
		_glutWindow::setup_cb(this, om);
	}
	else event_mask |= mask;
}
void glutWindow::create(int parent_win_id, int x, int y, int width, int height)
{
	_glutWindow::create(this, parent_win_id, x, y, width, height);
	_glutWindow::setup_cb(this);
}
void glutWindow::create(std::string const & name, int width, int height)
{
	_glutWindow::create(this, name, width, height);
	_glutWindow::setup_cb(this);
}
void glutWindow::destroy()
{
	assert(win_id);
	_glutWindow::destroy(this);
}
void glutWindow::set_current()
{
	assert(win_id);
	glutSetWindow(win_id);
}
void glutWindow::move(int x, int y)
{
	glutSetWindow(win_id);
	glutPositionWindow(x, y);
}
void glutWindow::resize(int width, int height)
{
	assert(win_id);
	glutSetWindow(win_id);
	glutReshapeWindow(width, height);
}
void glutWindow::redisplay()
{
	glutSetWindow(win_id);
	glutPostRedisplay();
}
namespace {
	unsigned idle_unique_id = 0;
	struct IdleEvent
	{
		unsigned idle_id;
		sigc::functor_base * fun;
	};
	std::list<IdleEvent> idle_event_list;
	void idle_func()
	{
		if (idle_event_list.size()) {
			IdleEvent e = idle_event_list.front();
			idle_event_list.pop_front();
			if (sigc::functor0<bool> * f = dynamic_cast<sigc::functor0<bool> *>(e.fun)) {
				if (f->call()) {
					idle_event_list.push_back(e);
					return;
				}
			}
			else if (sigc::functor0<void> * f = dynamic_cast<sigc::functor0<void> *>(e.fun)) {
				f->call();
			}
			if (! idle_event_list.size()) glutIdleFunc(0);
		}
		else glutIdleFunc(0);
	}
	struct _Idle :
		public sigc::signal_base
	{
		unsigned add_handle(sigc::slot_base const & slot)
		{
			throw Error("add_handle() called on idle_signal!");
		}
		void remove_handle(unsigned hid)
		{
			if (! idle_event_list.size()) return;
			for (std::list<IdleEvent>::iterator i = idle_event_list.begin(); i != idle_event_list.end(); i ++)
			if (i->idle_id == hid) {
				delete i->fun;
				idle_event_list.erase(i);
				break;
			}
			if (! idle_event_list.size()) {
				glutIdleFunc(0);
			}
		}
	} idle;
}
sigc::connection SignalIdle::connect(sigc::slot0<bool> const & slot)
{
	IdleEvent e;
	e.idle_id = idle_unique_id;
	e.fun = slot.fun->dup();
	idle_event_list.push_back(e);
	glutIdleFunc(& idle_func);
	return sigc::connection(& idle, unsigned(idle_unique_id ++));
}
void SignalIdle::connect_once(sigc::slot0<void> const & slot)
{
	IdleEvent e;
	e.idle_id = idle_unique_id;
	e.fun = slot.fun->dup();
	idle_event_list.push_back(e);
	glutIdleFunc(& idle_func);
	idle_unique_id ++;
}
namespace {
	struct glutFontInfo
	{
		void * font;
		int height;
		int ascent;
		int descent;
	} gf_info [] = {
		{GLUT_BITMAP_8_BY_13, 13, 11, 2},
		{GLUT_BITMAP_9_BY_15, 15, 13, 2},
		{GLUT_BITMAP_TIMES_ROMAN_10, 10, 7, 3},
		{GLUT_BITMAP_TIMES_ROMAN_24, 24, 18, 6},
		{GLUT_BITMAP_HELVETICA_10, 10, 8, 2},
		{GLUT_BITMAP_HELVETICA_12, 12, 9, 3},
		{GLUT_BITMAP_HELVETICA_18, 18, 15, 3},
		{0, 0, 0, 0}
	};
	glutFontInfo const & get_info(void * font)
	{
		size_t i = 0;
		while (gf_info[i].font && font != gf_info[i].font) i ++;
		return gf_info[i];
	}
}
int gltk::glut_get_font_height(void * font)
{
	return get_info(font).height;
}
int gltk::glut_get_font_ascent(void * font)
{
	return get_info(font).ascent;
}
int gltk::glut_get_font_descent(void * font)
{
	return get_info(font).descent;
}
void gltk::glut_draw_string(void * font, std::string const & text)
{
	for (size_t i = 0; i < text.size(); i ++) glutBitmapCharacter(font, text[i]);
}
void gltk::glut_draw_string(void * font, std::string const & text, int limit)
{
	int w = 0;
	for (size_t i = 0; i < text.size(); i ++) {
		w += glutBitmapWidth(font, text[i]);
		if (w > limit) return;
		glutBitmapCharacter(font, text[i]);
	}
}
int gltk::glut_get_string_width(void * font, std::string const & text)
{
	int w = 0;
	for (size_t i = 0; i < text.size(); i ++) w += glutBitmapWidth(font, text[i]);
	return w;
}
void gltk::glut_draw_raised_box(int x, int y, int w, int h)
{
	w = w + x;
	h = h + y;
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x + 0.5, h - 0.5);
	glVertex2f(x + 0.5, y + 0.5);
	glVertex2f(w - 0.5, y + 0.5);
	glEnd();
	glColor3f(0.8, 0.8, 0.8);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x + 1.5, h - 1.5);
	glVertex2f(x + 1.5, y + 1.5);
	glVertex2f(w - 1.5, y + 1.5);
	glEnd();
	glColor3f(0.4, 0.4, 0.4);
	glBegin(GL_LINE_STRIP);
	glVertex2f(w - 0.5, y + 0.5);
	glVertex2f(w - 0.5, h - 0.5);
	glVertex2f(x + 0.5, h - 0.5);
	glEnd();
	glColor3f(0.8, 0.8, 0.8);
	glBegin(GL_LINE_STRIP);
	glVertex2f(w - 1.5, y + 1.5);
	glVertex2f(w - 1.5, h - 1.5);
	glVertex2f(x + 1.5, h - 1.5);
	glEnd();
}
int gltk::glut_raised_box_width()
{
	return 2;
}
void gltk::glut_draw_sunken_box(int x, int y, int w, int h)
{
	w = w + x;
	h = h + y;
	glColor3f(0.8, 0.8, 0.8);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x + 0.5, h - 0.5);
	glVertex2f(x + 0.5, y + 0.5);
	glVertex2f(w - 0.5, y + 0.5);
	glEnd();
	glColor3f(0.4, 0.4, 0.4);
	glBegin(GL_LINE_STRIP);
	glVertex2f(x + 1.5, h - 1.5);
	glVertex2f(x + 1.5, y + 1.5);
	glVertex2f(w - 1.5, y + 1.5);
	glEnd();
	glColor3f(1.0, 1.0, 1.0);
	glBegin(GL_LINE_STRIP);
	glVertex2f(w - 0.5, y + 0.5);
	glVertex2f(w - 0.5, h - 0.5);
	glVertex2f(x + 0.5, h - 0.5);
	glEnd();
	glColor3f(0.8, 0.8, 0.8);
	glBegin(GL_LINE_STRIP);
	glVertex2f(w - 1.5, y + 1.5);
	glVertex2f(w - 1.5, h - 1.5);
	glVertex2f(x + 1.5, h - 1.5);
	glEnd();
}
int gltk::glut_sunken_box_width()
{
	return 2;
}
void Label::on_draw()
{
	int y = (get_height() - glut_get_font_height(font)) / 2 + glut_get_font_ascent(font);
	int w = glut_get_string_width(font, text);
	int x = max_of(1, (get_width() - w) / 2);
	glColor3f(0, 0, 0);
	glRasterPos2i(x, y);
	glut_draw_string(font, text, get_width() - 1);
}
void Label::get_preferred_height(int & min, int & nat) const
{
	int h = glut_get_font_height(font);
	min = h;
	nat = h + 2;
}
void Label::get_preferred_width(int & min, int & nat) const
{
	int w = 0;
	for (size_t i = 0; i < text.size(); i ++) w += glutBitmapWidth(font, text[i]);
	min = w;
	nat = w + 2;
}
Label::Label() :
	font(GLUT_BITMAP_HELVETICA_12)
{}
Label::Label(std::string const & label) :
	text(label),
	font(GLUT_BITMAP_HELVETICA_12)
{}
void Label::set_text(std::string const & label)
{
	text = label;
	if (get_realized()) glutPostRedisplay();
}
LabelBin::LabelBin(Widget * child) :
	own_child(false)
{
	add(child);
}
LabelBin::LabelBin(std::string const & name) :
	own_child(true)
{
	add(new Label(name));
}
LabelBin::~LabelBin()
{
}
void LabelBin::set_text(std::string name)
{
	if (Label * l = dynamic_cast<Label *>(child)) l->set_text(name);
}
Main::Main(int & argc, char * * (& argv))
{
	glutInit(& argc, argv);
	glutInitDisplayMode(GLUT_DOUBLE);
}
void Main::run(Window & w)
{
	w.show();
	glutMainLoop();
}
void PushBox::on_draw()
{
	draw_box();
}
void PushBox::get_preferred_width(int & min, int & nat) const
{
	min = box_width * 2;
	nat = min + 10;
}
void PushBox::get_preferred_height(int & min, int & nat) const
{
	min = box_width * 2;
	nat = min + 10;
}
void PushBox::on_button_event(int button, int state, int x, int y)
{
	if (button != GLUT_LEFT_BUTTON) return;
	if (state == GLUT_DOWN) {
		depressed = true;
		set_grabbing();
		pushed.emit();
	}
	else if (depressed) {
		set_grabbing(false);
		depressed = false;
		if (x >= 0 && y >= 0 && x < get_width() && y < get_height()) clicked.emit();
	}
	if (get_realized()) {
		glutSetWindow(get_realized());
		glutPostRedisplay();
	}
}
bool PushBox::on_key_event(unsigned char key)
{
	if (key == 0xd) {
		pushed.emit();
		clicked.emit();
		return true;
	}
	return false;
}
void PushBox::draw_box()
{
	int w = get_width();
	int h = get_height();
	int bw = glut_raised_box_width();
	glColor3f(0.9, 0.9, 0.9);
	glBegin(GL_QUADS);
	glVertex2i(bw, bw);
	glVertex2i(w - bw, bw);
	glVertex2i(w - bw, h - bw);
	glVertex2i(bw, h - bw);
	glEnd();
	if (depressed) {
		glColor3f(0.6, 0.6, 0.6);
		glBegin(GL_LINE_LOOP);
		glVertex2f(0.5, 0.5);
		glVertex2f(w - 0.5, 0.5);
		glVertex2f(w - 0.5 , h - 0.5);
		glVertex2f(0.5, h - 0.5);
		glEnd();
	}
	else glut_draw_raised_box(0, 0, w, h);
	if (focused) {
		glEnable(GL_LINE_STIPPLE);
		glLineStipple(1, 0x5555);
		glColor3f(0., 0., 0.);
		glBegin(GL_LINE_LOOP);
		double d = bw + 0.5;
		glVertex2f(d, d);
		glVertex2f(w - d, d);
		glVertex2f(w - d, h - d);
		glVertex2f(d, h - d);
		glEnd();
		glDisable(GL_LINE_STIPPLE);
	}
}
PushBox::PushBox() :
	box_width(4),
	depressed(false)
{}
void Scale::on_draw()
{
	int w = get_width();
	int h = get_height();
	int mw = w / 2;
	if (adjust) {
		double upper = adjust->get_upper();
		double lower = adjust->get_lower();
		double value = adjust->get_value();
		if (upper == lower) return;
		slider_y0 = (value - lower) * (h - slider_sz) / (upper - lower);
		glBegin(GL_QUADS);
		glColor3f(0.8, 0.8, 1.0);
		glVertex2i(0, 0);
		glVertex2i(0, slider_y0);
		glVertex2i(w, slider_y0);
		glVertex2i(w, 0);
		glEnd();
	}
	glBegin(GL_LINES);
	glColor3f(0.7, 0.7, 0.7);
	glVertex2f(mw - 0.5, slider_sz / 2.0);
	glVertex2f(mw - 0.5, h - slider_sz / 2.0);
	glColor3f(1.0, 1.0, 1.0);
	glVertex2f(mw + 0.5, slider_sz / 2.0);
	glVertex2f(mw + 0.5, h - slider_sz / 2.0);
	glEnd();
	if (adjust) {
		glBegin(GL_QUADS);
		glColor3f(0.9, 0.9, 0.9);
		glVertex2i(0, slider_y0);
		glVertex2i(0, slider_y0 + slider_sz);
		glVertex2i(w, slider_y0 + slider_sz);
		glVertex2i(w, slider_y0);
		glEnd();
		glut_draw_raised_box(0, slider_y0, w, slider_sz);
	}
}
void Scale::on_button_event(int button, int state, int x, int y)
{
	assert(adjust);
	if (button == GLUT_LEFT_BUTTON) {
		if (sliding) {
			assert(state == GLUT_UP);
			set_grabbing(false);
			sliding = false;
		}
		else if (state == GLUT_DOWN) {
			if (y < slider_y0) adjust->page_down();
			else if (y >= slider_y0 + slider_sz) adjust->page_up();
			else {
				set_grabbing();
				sliding = true;
				sliding_start = y;
				sliding_vs = adjust->get_value();
			}
		}
	}
	else if (button == 3) {
		if (state == GLUT_DOWN) adjust->step_down();
	}
	else if (button == 4) {
		if (state == GLUT_DOWN) adjust->step_up();
	}
}
void Scale::on_motion_event(int x, int y)
{
	assert(sliding);
	int dy = y - sliding_start;
	int rg = get_height() - slider_sz;
	if (! rg) return;
	double vr = adjust->get_upper() - adjust->get_lower();
	assert(vr > 0);
	double dv = dy * vr / rg;
	adjust->set_value(sliding_vs + dv);
}
void Scale::get_preferred_width(int & min, int & nat) const
{
	min = slider_sz;
	nat = slider_sz;
}
void Scale::get_preferred_height(int & min, int & nat) const
{
	min = 30;
	nat = 120;
}
Scale::Scale(Adjustment * adj) :
	adjust(adj),
	slider_sz(16),
	sliding(false)
{
	if (! adjust) adjust = new Adjustment;
	adjust->signal_value_changed().connect(sigc::mem_fun(this, & Scale::queue_draw));
}
Adjustment * Scale::get_adjustment()
{
	return adjust;
}
void Scale::set_value(double value)
{
	assert(adjust);
	adjust->set_value(value);
}
double Scale::get_value() const
{
	return adjust->get_value();
}
sigc::signal<void> & Scale::signal_value_changed()
{
	assert(adjust);
	return adjust->signal_value_changed();
}
void Shape::on_draw()
{
	int w = get_width();
	int h = get_height();
	switch (shape) {
	case UP_TRIANGLE:
		glColor3f(0, 0, 0);
		glBegin(GL_TRIANGLES);
		glVertex2f(0, h);
		glVertex2f(w / 2.0, 0);
		glVertex2f(w, h);
		glEnd();
		break;
	case DOWN_TRIANGLE:
		glColor3f(0, 0, 0);
		glBegin(GL_TRIANGLES);
		glVertex2f(0, 0);
		glVertex2f(w / 2.0, h);
		glVertex2f(w, 0);
		glEnd();
		break;
	default:
		throw Error("Unknown shape");
	}
}
void Shape::get_preferred_width(int & min, int & nat) const
{
	min = 0;
	nat = width;
}
void Shape::get_preferred_height(int & min, int & nat) const
{
	min = 0;
	nat = height;
}
Shape::Shape(Predefined s, int w, int h) :
	shape(s),
	width(w),
	height(h)
{
}
void SpinButton::on_configure_event()
{
	int height = get_height();
	int width = get_width();
	int h2 = height / 2;
	int h = min_of(h2, 7);
	if (width < 10) {
		tx.size_allocate(0, 0, width, height);
		up.size_allocate(width, h2 - h, 0, h);
		dn.size_allocate(width, h2, 0, h);
	}
	else {
		int x = width - 10;
		tx.size_allocate(0, 0, x, height);
		up.size_allocate(x, h2 - h, 10, h);
		dn.size_allocate(x, h2, 10, h);
	}
}
void SpinButton::on_draw()
{
	draw_children();
}
void SpinButton::on_value_changed()
{
	std::ostringstream ss;
	ss << std::fixed << std::setprecision(digits) << get_value();
	tx.set_text(ss.str());
	if (get_realized()) {
		glutSetWindow(get_realized());
		glutPostRedisplay();
	}
}
void SpinButton::on_button_event(int button, int state, int x, int y)
{
	if (button == GLUT_LEFT_BUTTON) {
		if (grabber) {
			assert(state == GLUT_UP);
			grabber->button_event(button, state, x, y);
			assert(! grabber);
			if (held) {
				held_timeout.disconnect();
				held = false;
			}
		}
		else if (Widget * w = get_child(x, y)) {
			w->button_event(button, state, x, y);
		}
		if (grabber && ! held && grabber != & tx) {
			spin_interval = spin_wait / 2;
			climb_value = step_increment;
			held_timeout = SignalTimeout::connect(sigc::mem_fun(this, & SpinButton::button_held), spin_wait);
			held = true;
			spinning = false;
		}
	}
	else if (button == 3) {
		if (state == GLUT_DOWN) pushed_up();
	}
	else if (button == 4) {
		if (state == GLUT_DOWN) pushed_dn();
	}
}
bool SpinButton::on_special_event(int key)
{
	if (! focus) return false;
	if (focus == & tx) {
		switch (key) {
		case GLUT_KEY_UP:
			pushed_up();
			break;
		case GLUT_KEY_DOWN:
			pushed_dn();
			break;
		case GLUT_KEY_PAGE_UP:
			page_up();
			break;
		case GLUT_KEY_PAGE_DOWN:
			page_down();
			break;
		default:
			return focus->special_event(key);
		}
		tx.select_all();
		return true;
	}
	return focus->special_event(key);
}
void SpinButton::value_enter()
{
	std::istringstream s(tx.get_text());
	double v;
	s >> v;
	if (snap_to_ticks) v = step_increment * round_int(v / step_increment);
	if (v != get_value()) set_value(v);
	else {
		std::ostringstream ss;
		ss << std::fixed << std::setprecision(digits) << get_value();
		tx.set_text(ss.str());
		if (get_realized()) glutPostRedisplay();
	}
}
void SpinButton::value_stop()
{
	std::ostringstream ss;
	ss << std::fixed << std::setprecision(digits) << get_value();
	tx.set_text(ss.str());
}
bool SpinButton::button_held()
{
	if (! grabber) {
		held = false;
		return false;
	}
	spinning = true;
	double v = get_value();
	if (grabber == & up) {
		v += climb_value;
		if (wrap && v > upper) v = lower;
	}
	else if (grabber == & dn) {
		v -= climb_value;
		if (wrap && v < lower) v = upper;
	}
	else throw Error("Unknown grabber...");
	if (snap_to_ticks) v = step_increment * round_int(v / step_increment);
	set_value(v);
	spin_interval -= (spin_interval / 3);
	spin_interval = max_of(spin_interval, spin_wait / 10);
	climb_value += climb_value * climb_rate / 10;
	if (climb_value > page_increment) climb_value = (page_increment + climb_value) / 2;
	held_timeout = SignalTimeout::connect(sigc::mem_fun(this, & SpinButton::button_held), spin_interval);
	return false;
}
void SpinButton::pushed_up()
{
	double v = get_value() + step_increment;
	if (wrap && v > upper) v = lower;
	if (snap_to_ticks) v = step_increment * round_int(v / step_increment);
	set_value(v);
}
void SpinButton::pushed_dn()
{
	double v = get_value() - step_increment;
	if (wrap && v < lower) v = upper;
	if (snap_to_ticks) v = step_increment * round_int(v / step_increment);
	set_value(v);
}
SpinButton::SpinButton(double c_rate, unsigned dgts) :
	up(new Shape(Shape::UP_TRIANGLE, 8, 4)),
	dn(new Shape(Shape::DOWN_TRIANGLE, 8, 4)),
	spin_wait(700),
	held(false),
	spinning(false),
	climb_rate(c_rate),
	digits(dgts),
	snap_to_ticks(false),
	wrap(false)
{
	add(& tx);
	add(& up);
	add(& dn);
	up.set_reserved(3, 3);
	dn.set_reserved(3, 3);
	up.set_box_width(1);
	dn.set_box_width(1);
	up.signal_pushed().connect(sigc::mem_fun(this, & SpinButton::pushed_up));
	dn.signal_pushed().connect(sigc::mem_fun(this, & SpinButton::pushed_dn));
	std::ostringstream s;
	s << std::fixed << std::setprecision(digits) << get_value();
	tx.set_text(s.str());
	tx.signal_activate().connect(sigc::mem_fun(this, & SpinButton::value_enter));
	tx.signal_stop().connect(sigc::mem_fun(this, & SpinButton::value_stop));
}
void SpinButton::get_preferred_width(int & min, int & nat) const
{
	tx.get_preferred_width(min, nat);
	min += 10;
	nat += 10;
}
void SpinButton::get_preferred_height(int & min, int & nat) const
{
	tx.get_preferred_height(min, nat);
	min = max_of(min, 10);
	nat = max_of(nat, 16);
}
int SpinButton::get_value_as_int() const
{
	int v = get_value();
	return v;
}
unsigned SpinButton::get_digits() const
{
	return digits;
}
void SpinButton::set_digits(unsigned d)
{
	digits = d;
	std::ostringstream ss;
	ss << std::fixed << std::setprecision(digits) << get_value();
	tx.set_text(ss.str());
	tx.select_none();
	if (get_realized()) glutPostRedisplay();
}
void SpinButton::set_snap_to_ticks(bool snap)
{
	snap_to_ticks = snap;
	if (snap) {
		double v = step_increment * round_int(get_value() / step_increment);
		set_value(v);
	}
}
void SpinButton::set_increments(double step, double page)
{
	set_step_increment(step);
	set_page_increment(page);
	if (snap_to_ticks) {
		double v = step_increment * round_int(get_value() / step_increment);
		set_value(v);
	}
}
void SpinButton::set_range(double min, double max)
{
	set_upper(max);
	set_lower(min);
}
void SpinButton::set_wrap(bool w)
{
	wrap = w;
}
void SpinButton::set_width_chars(int n_chars)
{
	tx.set_width_chars(n_chars);
}
namespace {
	int timer_unique_id = 0;
	struct TimerEvent
	{
		sigc::functor_base * fun;
		unsigned interval;
	};
	std::map<int, TimerEvent> timer_event_list;
	void timer_func(int v)
	{
		std::map<int, TimerEvent>::iterator i = timer_event_list.find(v);
		if (i == timer_event_list.end()) return;
		if (sigc::functor0<bool> * f = dynamic_cast<sigc::functor0<bool> *>(i->second.fun)) {
			if (f->call()) {
				glutTimerFunc(i->second.interval, & timer_func, v);
				return;
			}
		}
		else if (sigc::functor0<void> * f = dynamic_cast<sigc::functor0<void> *>(i->second.fun)) {
			f->call();
		}
		delete i->second.fun;
		timer_event_list.erase(i);
	}
	struct _Timeout :
		public sigc::signal_base
	{
		unsigned add_handle(sigc::slot_base const & slot)
		{
			throw Error("add_handle() called on timeout_signal!");
		}
		void remove_handle(unsigned hid)
		{
			int v = hid;
			std::map<int, TimerEvent>::iterator i = timer_event_list.find(v);
			if (i == timer_event_list.end()) return;
			delete i->second.fun;
			timer_event_list.erase(i);
		}
	} timeout;
}
sigc::connection SignalTimeout::connect(sigc::slot0<bool> const & slot, unsigned interval)
{
	TimerEvent & e = timer_event_list[timer_unique_id];
	e.fun = slot.fun->dup();
	e.interval = interval;
	glutTimerFunc(interval, & timer_func, timer_unique_id);
	return sigc::connection(& timeout, unsigned(timer_unique_id ++));
}
void SignalTimeout::connect_once(sigc::slot0<void> const & slot, unsigned interval)
{
	TimerEvent & e = timer_event_list[timer_unique_id];
	e.fun = slot.fun->dup();
	e.interval = interval;
	glutTimerFunc(interval, & timer_func, timer_unique_id);
	timer_unique_id ++;
}
Widget::Widget() :
	parent(0),
	managed(false),
	realized_win(0),
	grabbing(false),
	shown(false),
	alloc_x(- 1),
	alloc_y(- 1),
	alloc_w(- 1),
	alloc_h(- 1)
{}
Widget::~Widget()
{
}
void Widget::get_preferred_width(int & min, int & nat) const
{
	min = 0;
	nat = 0;
}
void Widget::get_preferred_height(int & min, int & nat) const
{
	min = 0;
	nat = 0;
}
void Widget::get_preferred_height_for_width(int width, int & min, int & nat) const
{
	get_preferred_height(min, nat);
}
void Widget::get_preferred_width_for_height(int height, int & min, int & nat) const
{
	get_preferred_width(min, nat);
}
bool Widget::focus_make()
{
	return false;
}
bool Widget::focus_next()
{
	focus_end();
	return false;
}
bool Widget::get_focus()
{
	if (! parent) return false;
	return parent->focus_on(this);
}
void Widget::set_parent(Container * p)
{
	parent = p;
}
void Widget::set_managed(bool v)
{
	managed = v;
}
bool Widget::get_managed() const
{
	return managed;
}
void Widget::realize(int win)
{
	if (realized_win) throw Error("Already realized!");
	realized_win = win;
	configured = false;
	on_realize(win);
}
void Widget::unrealize()
{
	if (! realized_win) throw Error("Not realized!");
	realized_win = false;
	on_unrealize();
}
void Widget::size_allocate(int x, int y, int width, int height)
{
	alloc_x = x;
	alloc_y = y;
	if (alloc_w != width || alloc_h != height) {
		alloc_w = width;
		alloc_h = height;
	}
	configured = true;
	on_configure_event();
}
void Widget::move_allocate(int x, int y)
{
	assert(configured);
	alloc_x = x;
	alloc_y = y;
	on_configure_event();
}
bool Widget::contains(int x, int y) const
{
	return x >= alloc_x && y >= alloc_y && x - alloc_x < alloc_w && y - alloc_y < alloc_h;
}
void Widget::draw()
{
	if (alloc_w > 0 && alloc_h > 0) {
		if (alloc_x > 0 || alloc_y > 0) glTranslatef(alloc_x, alloc_y, 0);
		on_draw();
	}
}
void Widget::show()
{
	shown = true;
	on_show();
}
void Widget::hide()
{
	on_hide();
	shown = false;
}
void Widget::make_focus()
{
	if (focus_make()) {
		if (! get_focus()) focus_end();
	}
}
void Widget::button_event(int button, int state, int x, int y)
{
	if (alloc_x > 0 || alloc_y > 0) {
		x -= alloc_x;
		y -= alloc_y;
	}
	on_button_event(button, state, x, y);
}
void Widget::motion_event(int x, int y)
{
	if (alloc_x > 0 || alloc_y > 0) {
		x -= alloc_x;
		y -= alloc_y;
	}
	on_motion_event(x, y);
}
bool Widget::keyboard_event(unsigned char key)
{
	return on_key_event(key);
}
bool Widget::special_event(int key)
{
	return on_special_event(key);
}
void Widget::passive_event(int x, int y)
{
	if (alloc_x > 0 || alloc_y > 0) {
		x -= alloc_x;
		y -= alloc_y;
	}
	on_passive_event(x, y);
}
void Widget::entry_event(bool entered)
{
	on_entry_event(entered);
}
void Widget::set_grabbing(bool v)
{
	if (grabbing == v) return;
	grabbing = v;
	if (parent) parent->set_grabber(this, v);
}
int Widget::get_realized() const
{
	return realized_win;
}
Allocation Widget::get_allocation() const
{
	Allocation a = {alloc_x, alloc_y, alloc_w, alloc_h};
	return a;
}
void Widget::get_absolute(int & x, int & y) const
{
	assert(realized_win);
	if (parent && parent->realized_win == realized_win) {
		parent->get_absolute(x, y);
		assert(alloc_x >= 0 &&  alloc_y >= 0);
		x += alloc_x;
		y += alloc_y;
	}
	else {
		x = alloc_x;
		y = alloc_y;
	}
}
void Widget::queue_draw()
{
	if (! realized_win) return;
	glutSetWindow(realized_win);
	glutPostRedisplay();
}
size_t Window::visible_count = 0;
void Window::on_display_func()
{
	glDisable(GL_LIGHTING);
	glViewport(0, 0, win_width, win_height);
	glMatrixMode(GL_PROJECTION);
	glLoadIdentity();
	glOrtho(0, win_width, win_height, 0, 1, - 1);
	glMatrixMode(GL_MODELVIEW);
	glLoadIdentity();
	glColor3f(0.9, 0.9, 0.9);
	glBegin(GL_QUADS);
	glVertex2d(0, 0);
	glVertex2d(0, win_height);
	glVertex2d(win_width, win_height);
	glVertex2d(win_width, 0);
	glEnd();
	draw_children();
	glutSwapBuffers();
}
void Window::on_reshape_func(int width, int height)
{
	win_width = width;
	win_height = height;
	size_allocate(0, 0, width, height);
}
void Window::on_mouse_func(int button, int state, int x, int y)
{
	button_event(button, state, x, y);
}
void Window::on_motion_func(int x, int y)
{
	motion_event(x, y);
}
void Window::on_passive_func(int x, int y)
{
	passive_event(x, y);
}
void Window::on_keyboard_func(unsigned char key, int x, int y)
{
	if (key == 0x9) {
		((Widget *) this)->focus_next();
		return;
	}
	if (! keyboard_event(key)) std::cerr << "unhandled key: 0x" << std::hex << int(key) << '\n';
}
void Window::on_special_func(int key, int x, int y)
{
	if (! special_event(key)) std::cerr << "unhandled special: 0x" << std::hex << key << '\n';
}
void Window::on_create()
{
	assert(get_win_id());
	realize_children(get_win_id());
}
void Window::on_destroy()
{
	unrealize_children();
	if (visible) {
		visible = false;
		visible_count --;
	}
}
bool Window::get_focus()
{
	return true;
}
Window::Window() :
	visible(false),
	default_w(0),
	default_h(0)
{
	set_events(
		DISPLAY_MASK |
		RESHAPE_MASK |
		MOUSE_MASK |
		MOTION_MASK |
		PASSIVE_MASK |
		KEYBOARD_MASK |
		SPECIAL_MASK
	);
}
Window::~Window()
{
	if (visible) visible_count --;
}
void Window::set_default_size(int w, int h)
{
	default_w = w;
	default_h = h;
}
void Window::set_title(std::string const & txt)
{
	title = txt;
	if (get_realized()) {
		glutSetWindow(get_win_id());
		glutSetWindowTitle(title.c_str());
	}
}
void Window::resize(int w, int h)
{
	if (get_win_id()) glutWindow::resize(w, h);
}
void Window::refresh()
{
	redisplay();
}
void Window::show()
{
	if (int wid = get_win_id()) glutSetWindow(wid);
	else {
		int mw;
		int nw;
		get_preferred_width(mw, nw);
		if (default_w) nw = max_of(mw, default_w);
		else if (! nw) nw = 200;
		int mh;
		int nh;
		get_preferred_height_for_width(nw, mh, nh);
		if (default_h) nh = max_of(mh, default_h);
		else if (! nh) nh = 200;
		create(title, nw, nh);
	}
	glutShowWindow();
	if (! visible) {
		visible = true;
		visible_count ++;
	}
}
void Window::hide()
{
	if (int wid = get_win_id()) {
		glutSetWindow(wid);
		glutHideWindow();
		if (visible) {
			visible = false;
			visible_count --;
			if (! visible_count) {
				destroy();
				exit(0);
			}
		}
	}
}
