/* GENERATED, DO NOT EDIT! See http://gltk.ccdw.org/ for source. */
/* gltk_Q5B.hh: adjustment bin box button checkbox checkbutton container entry focusable glarea glutwindow idle label labelbin main pushbox scale shape spinbutton timeout widget window
 *
 * Copyright (C) 2011 Chun-Chung Chen <cjj@u.washington.edu>
 *
 * This file was generated from gltk.
 *
 * gltk is free software: you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public
 * License along with arg.  If not, see <http://www.gnu.org/licenses/>.
 * 
*/
#ifndef GLTK_GLTK_HH
#define GLTK_GLTK_HH
#include <vector>
#include <list>
#include <string>
#include <iostream>
#include <map>
#ifdef __APPLE__
#include <GLUT/glut.h>
#else
#ifndef FREEGLUT
#include <cstdlib>
#endif
#include <GL/glut.h>
#endif
namespace sigc {
	struct nil;
	struct functor_base
	{
		virtual functor_base * dup() const = 0;
		virtual ~functor_base() {}
	};
	struct slot_base
	{
		functor_base * fun;
		slot_base() : fun(0) {}
		virtual ~slot_base() {delete fun;}
	};
	struct signal_base
	{
		unsigned hcnt;
		struct handle
		{
			unsigned hid;
			functor_base * fun;
			handle(unsigned h, functor_base const * f) : hid(h), fun(f->dup()) {}
		};
		std::list<handle> handle_list;
		signal_base() : hcnt(0) {}
		virtual unsigned add_handle(slot_base const & slot)
		{
			handle_list.push_back(handle(hcnt, slot.fun));
			return hcnt ++;
		}
		virtual void remove_handle(unsigned hid)
		{
			for (std::list<handle>::iterator i = handle_list.begin(); i != handle_list.end(); i ++)
			if (hid == i->hid) {
				delete i->fun;
				handle_list.erase(i);
				return;
			}
		}
		size_t size() {return handle_list.size();}
		~signal_base()
		{
			for (std::list<handle>::iterator i = handle_list.begin(); i != handle_list.end(); i ++) {
				delete i->fun;
			}
		}
	};
	struct connection
	{
		signal_base * signal;
		unsigned hid;
		connection() : signal(0) {}
		connection(signal_base * s, unsigned h) : signal(s), hid(h) {}
		bool is_connected() {return signal;}
		void disconnect()
		{
			if (signal) {
				signal->remove_handle(hid);
				signal = 0;
			}
		}
	};
	template <typename Tr>
	struct functor0 :
		public functor_base
	{
		virtual Tr call() = 0;
	};
	template <typename Tr>
	struct functor0_ptr :
		functor0<Tr>
	{
		Tr (* ptr)();
		Tr call() {return (* ptr)();}
		functor_base * dup() const {return new functor0_ptr<Tr>(* this);}
	};
	template <>
	struct functor0_ptr<void> :
		functor0<void>
	{
		void (* ptr)();
		void call() {(* ptr)();}
		functor_base * dup() const {return new functor0_ptr<void>(* this);}
	};
	template <typename C, typename Cp, typename Tr>
	struct functor0_mem :
		functor0<Tr>
	{
		C * cls;
		Tr (Cp::* ptr)();
		Tr call() {return (cls->* ptr)();}
		functor_base * dup() const {return new functor0_mem<C, Cp, Tr>(* this);}
	};
	template <typename C, typename Cp>
	struct functor0_mem<C, Cp, void> :
		functor0<void>
	{
		C * cls;
		void (Cp::* ptr)();
		void call() {(cls->* ptr)();}
		functor_base * dup() const {return new functor0_mem<C, Cp, void>(* this);}
	};
	template <typename Tr>
	struct slot0 :
		public slot_base
	{
		Tr call() {return dynamic_cast<functor0<Tr> *>(fun)->call();}
		slot0(slot0<Tr> const & s) {fun = s.fun->dup();}
		slot0(functor0<Tr> const & f) {fun = f.dup();}
	};
	template <>
	struct slot0<void> :
		public slot_base
	{
		void call() {dynamic_cast<functor0<void> *>(fun)->call();}
		slot0(slot0<void> const & s) {fun = s.fun->dup();}
		slot0(functor0<void> const & f) {fun = f.dup();}
	};
	template <typename Tr>
	slot0<Tr> ptr_fun(Tr (* ptr)())
	{
		functor0_ptr<Tr> f;
		f.ptr = ptr;
		return f;
	}
	template <typename C, typename Cp, typename Tr>
	slot0<Tr> mem_fun(C * cls, Tr (Cp::* ptr)())
	{
		functor0_mem<C, Cp, Tr> f;
		f.cls = cls;
		f.ptr = ptr;
		return f;
	}
	template <typename C, typename Cp, typename Tr>
	slot0<Tr> mem_fun(C & cls, Tr (Cp::* ptr)())
	{
		functor0_mem<C, Cp, Tr> f;
		f.cls = & cls;
		f.ptr = ptr;
		return f;
	}
	template <typename Tr>
	struct signal0 :
		public signal_base
	{
		connection connect(slot0<Tr> const & s)
		{
			return connection(this, add_handle(s));
		}
		Tr emit()
		{
			Tr v;
			for (typename std::list<handle>::iterator i = handle_list.begin(); i != handle_list.end(); i ++) {
				v = dynamic_cast<functor0<Tr> *>(i->fun)->call();
			}
			return v;
		}
		slot0<Tr> make_slot()
		{
			return mem_fun(this, & signal0<Tr>::emit);
		}
	};
	template <>
	struct signal0<void> :
		public signal_base
	{
		connection connect(slot0<void> const & s)
		{
			return connection(this, add_handle(s));
		}
		void emit()
		{
			for (std::list<handle>::iterator i = handle_list.begin(); i != handle_list.end(); i ++) {
				dynamic_cast<functor0<void> *>(i->fun)->call();
		        }
		}
		slot0<void> make_slot()
		{
			return mem_fun(this, & signal0<void>::emit);
		}
	};
	template <typename Tr, typename T1>
	struct functor1 :
		public functor_base
	{
		virtual Tr call(T1) = 0;
	};
	template <typename Tr, typename T1>
	struct functor1_ptr :
		functor1<Tr, T1>
	{
		Tr (* ptr)(T1);
		Tr call(T1 t1) {return (* ptr)(t1);}
		functor_base * dup() const {return new functor1_ptr<Tr, T1>(* this);}
	};
	template <typename T1>
	struct functor1_ptr<void, T1> :
		functor1<void, T1>
	{
		void (* ptr)(T1);
		void call(T1 t1) {(* ptr)(t1);}
		functor_base * dup() const {return new functor1_ptr<void, T1>(* this);}
	};
	template <typename C, typename Cp, typename Tr, typename T1>
	struct functor1_mem :
		functor1<Tr, T1>
	{
		C * cls;
		Tr (C::* ptr)(T1);
		Tr call(T1 t1) {return (cls->* ptr)(t1);}
		functor_base * dup() const {return new functor1_mem<C, Cp, Tr, T1>(* this);}
	};
	template <typename C, typename Cp, typename T1>
	struct functor1_mem<C, Cp, void, T1> :
		functor1<void, T1>
	{
		C * cls;
		void (C::* ptr)(T1);
		void call(T1 t1) {(cls->* ptr)(t1);}
		functor_base * dup() const {return new functor1_mem<C, Cp, void, T1>(* this);}
	};
	template <typename Tr, typename T1>
	struct slot1 :
		public slot_base
	{
		Tr call(T1 t1) {return dynamic_cast<functor1<Tr, T1> *>(fun)->call(t1);}
		slot1(slot1<Tr, T1> const & s) {fun = s.fun->dup();}
		slot1(functor1<Tr, T1> const & f) {fun = f.dup();}
	};
	template <typename T1>
	struct slot1<void, T1> :
		public slot_base
	{
		void call(T1 t1) {dynamic_cast<functor1<void, T1> *>(fun)->call(t1);}
		slot1(slot1<void, T1> const & s) {fun = s.fun->dup();}
		slot1(functor1<void, T1> const & f) {fun = f.dup();}
	};
	template <typename Tr, typename T1>
	slot1<Tr, T1> ptr_fun(Tr (* ptr)(T1))
	{
		functor1_ptr<Tr, T1> f;
		f.ptr = ptr;
		return f;
	}
	template <typename C, typename Cp, typename Tr, typename T1>
	slot1<Tr, T1> mem_fun(C * cls, Tr (Cp::* ptr)(T1))
	{
		functor1_mem<C, Cp, Tr, T1> f;
		f.cls = cls;
		f.ptr = ptr;
		return f;
	}
	template <typename C, typename Cp, typename Tr, typename T1>
	slot1<Tr, T1> mem_fun(C & cls, Tr (Cp::* ptr)(T1))
	{
		functor1_mem<C, Cp, Tr, T1> f;
		f.cls = & cls;
		f.ptr = ptr;
		return f;
	}
	template <typename Tr, typename T1>
	struct signal1 :
		public signal_base
	{
		connection connect(slot1<Tr, T1> const & s)
		{
			return connection(this, add_handle(s));
		}
		Tr emit(T1 t1)
		{
			Tr v = Tr();
			for (typename std::list<handle>::iterator i = handle_list.begin(); i != handle_list.end(); i ++) {
				v = dynamic_cast<functor1<Tr, T1> *>(i->fun)->call(t1);
			}
                        return v;
		}
		slot1<Tr, T1> make_slot()
		{
			return mem_fun(this, & signal1<Tr, T1>::emit);
		}
	};
	template <typename T1>
	struct signal1<void, T1> :
		public signal_base
	{
		connection connect(slot1<void, T1> const & s)
		{
			return connection(this, add_handle(s));
		}
		void emit(T1 t1)
		{
			for (typename std::list<handle>::iterator i = handle_list.begin(); i != handle_list.end(); i ++) {
				(* dynamic_cast<functor1<void, T1> *>(i->fun)).call(t1);
			}
		}
		slot1<void, T1> make_slot()
		{
			return mem_fun(this, & signal1<void, T1>::emit);
		}
	};
	template <typename Tr, typename T1 = nil>
	struct slot :
		public slot1<Tr, T1>
	{
		slot() {}
		slot(slot1<Tr, T1> const & s) : slot1<Tr, T1>(s) {}
	};
	template <typename Tr>
	struct slot<Tr, nil> :
		public slot0<Tr>
	{
		slot() {}
		slot(slot0<Tr> const & s) : slot0<Tr>(s) {}
	};
	template <typename Tr, typename T1 = nil>
	struct signal :
		public signal1<Tr, T1>
	{
		signal() {}
	};
	template <typename Tr>
	struct signal<Tr, nil> :
		public signal0<Tr>
	{
		signal() {}
	};
	template <typename Tr, typename D1>
	struct adaptor0 :
		public functor0<Tr>
	{
		functor1<Tr, D1> * fun;
		D1 d1;
		adaptor0(functor1<Tr, D1> * f, D1 v1) : fun(f->dup()), d1(v1) {}
		Tr call() {return dynamic_cast<functor1<Tr, D1> *>(fun)->call(d1);}
		functor_base * dup() {return new adaptor0<Tr, D1>(fun, d1);}
	};
	template <typename D1>
	struct adaptor0<void, D1> :
		public functor0<void>
	{
		functor1<void, D1> * fun;
		D1 d1;
		adaptor0(functor1<void, D1> const * f, D1 v1) : fun(dynamic_cast<functor1<void, D1> *>(f->dup())), d1(v1) {}
		void call() {dynamic_cast<functor1<void, D1> *>(fun)->call(d1);}
		functor_base * dup() const {return new adaptor0<void, D1>(fun, d1);}
	};
	template <typename Tr, typename T1>
	slot0<Tr> bind(slot1<Tr, T1> const & s, T1 v)
	{
		return slot0<Tr>(adaptor0<Tr, T1>(dynamic_cast<functor1<Tr, T1> *>(s.fun), v));
	}
}
namespace gltk {
	class Adjustment
	{
		sigc::signal<void> value_changed;
	protected:
		double value;
		double lower;
		double upper;
		double step_increment;
		double page_increment;
		double page_size;
		virtual void on_value_changed() {};
	public:
		Adjustment();
		Adjustment(
			double value,
			double lower,
			double upper,
			double step_increment,
			double page_increment,
			double page_size
		);
		void configure(
			double value,
			double lower,
			double upper,
			double step_increment=1,
			double page_increment=10,
			double page_size=0
		);
		double get_value() const;
		void set_value(double value);
		void step_up();
		void step_down();
		void page_up();
		void page_down();
		void set_step_increment(double step_increment);
		void set_page_increment(double page_increment);
		double get_upper() const {return upper;}
		void set_upper (double upper);
		double get_lower() const {return lower;}
		void set_lower (double lower);
		double get_page_size() const {return page_size;}
		sigc::signal<void> & signal_value_changed();
	};
	class Container;
	struct Allocation
	{
		int x;
		int y;
		int width;
		int height;
	};
	template<typename T>
	T * manage(T * obj)
	{
		obj->set_managed();
		return obj;
	}
	class Widget
	{
		Container * parent;
		bool managed;
		int realized_win;
		bool grabbing;
		bool shown;
		bool configured;
		int alloc_x;
		int alloc_y;
		int alloc_w;
		int alloc_h;
	protected:
		virtual void on_realize(int win) {}
		virtual void on_unrealize() {}
		virtual void on_draw() {}
		virtual void on_size_allocate(int width, int height) {}
		virtual void on_configure_event() {}
		virtual void on_button_event(int button, int state, int x, int y) {}
		virtual void on_motion_event(int x, int y) {}
		virtual void on_passive_event(int x, int y) {}
		virtual bool on_key_event(unsigned char key) {return false;}
		virtual bool on_special_event(int key) {return false;}
		virtual void on_entry_event(bool entered) {}
		virtual void on_set_parent(Container * p) {}
		virtual void on_show() {}
		virtual void on_hide() {}
		virtual bool get_focus();
	public:
		Widget();
		virtual ~Widget();
		virtual void get_preferred_height(int & min, int & nat) const;
		virtual void get_preferred_height_for_width(int width, int & min, int & nat) const;
		virtual void get_preferred_width(int & min, int & nat) const;
		virtual void get_preferred_width_for_height(int height, int & min, int & nat) const;
		virtual bool focus_make();
		virtual bool focus_next();
		virtual void focus_end() {}
		void set_parent(Container * p);
		void set_managed(bool v = true);
		bool get_managed() const;
		void realize(int win);
		void unrealize();
		void size_allocate(int x, int y, int width, int height);
		void move_allocate(int x, int y);
		bool contains(int x, int y) const;
		void draw();
		void show();
		void hide();
		void make_focus();
		void button_event(int button, int state, int x, int y);
		void motion_event(int x, int y);
		bool keyboard_event(unsigned char key);
		bool special_event(int key);
		void passive_event(int x, int y);
		void entry_event(bool enterred);
		void set_grabbing(bool v = true);
		int get_realized() const;
		int get_shown() const {return shown;}
		int get_width() const {return alloc_w;}
		int get_height() const {return alloc_h;}
		Allocation get_allocation() const;
		void get_absolute(int & x, int & y) const;
		void queue_draw();
	};
	class Container :
		public virtual Widget
	{
		void on_realize(int win);
		void on_unrealize();
		void on_draw();
		void on_button_event(int button, int state, int x, int y);
		void on_motion_event(int x, int y);
		void on_passive_event(int x, int y);
		bool on_key_event(unsigned char key);
		bool on_special_event(int key);
		void on_entry_event(bool entered);
		bool focus_make();
		bool focus_next();
		void focus_end();
	protected:
		Widget * get_child(int x, int y);
		std::vector<Widget *> child_list;
		Widget * grabber;
		Widget * focus;
		Widget * tracker;
		virtual void on_add(Widget *) {}
		virtual void on_remove(Widget *) {}
		void draw_children();
		void realize_children(int win);
		void unrealize_children();
	public:
		Container();
		~Container();
		void add(Widget * child);
		void add(Widget & child) {add(& child);}
		void remove(Widget * child);
		void show_all();
		void show_all_children(bool recursive = true);
		void set_grabber(Widget * child, bool grab = true);
		virtual bool focus_on(Widget * child);
	};
	class Bin :
		public virtual Container
	{
		int child_x;
		int child_y;
	protected:
		void on_configure_event() ;
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		void get_preferred_width_for_height(int height, int & min, int & nat) const;
		void get_preferred_height_for_width(int width, int & min, int & nat) const;
		void on_add(Widget *);
		void on_remove(Widget *);
		Widget * child;
		int reducible_x;
		int reducible_y;
		int reserved_x;
		int reserved_y;
	public:
		Bin();
		void set_reducible(int x, int y);
		void set_reserved(int x, int y);
		void place_bin(int x, int y);
		void set_border_width(unsigned w);
	};
	class Box :
		public Container
	{
	public:
		enum Orientation {
			HORIZONTAL,
			VERTICAL
		};
	private:
		void on_configure_event();
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		void get_preferred_width_for_height(int height, int & min, int & nat) const;
		void get_preferred_height_for_width(int width, int & min, int & nat) const;
	protected:
		Orientation orientation;
		unsigned border_width;
		int spacing;
		bool homogeneous;
	public:
		Box(
			Orientation orientabtion = HORIZONTAL,
			int spacing = 0
		);
		void pack_start(Widget * child);
		void pack_start(Widget & child) {pack_start(& child);}
		void set_border_width(unsigned border_width);
	};
	class Focusable :
		virtual public Widget
	{
	protected:
		bool focused;
		bool focus_make();
		bool focus_next();
		void focus_end();
		virtual void draw_focus_box();
	public:
		Focusable();
	};
	class PushBox :
		public virtual Focusable
	{
		sigc::signal<void> pushed;
		sigc::signal<void> clicked;
	protected:
		void on_draw();
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		void on_button_event(int button, int state, int x, int y);
		bool on_key_event(unsigned char key);
		int box_width;
		bool depressed;
		void draw_box();
	public:
		PushBox();
		sigc::signal<void> & signal_clicked() {return clicked;}
		sigc::signal<void> & signal_pushed() {return pushed;}
		void set_box_width (int bw) {box_width = bw;}
	};
	class LabelBin :
		virtual public Bin
	{
		bool own_child;
	public:
		LabelBin(Widget * child);
		LabelBin(std::string const & name);
		~LabelBin();
		void set_text(std::string name);
	};
	class Button :
		virtual public PushBox,
		virtual public LabelBin
	{
		void on_draw();
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		void get_preferred_width_for_height(int height, int & min, int & nat) const;
		void get_preferred_height_for_width(int width, int & min, int & nat) const;
		bool focus_make();
		bool focus_next();
		void focus_end();
		void on_button_event(int button, int state, int x, int y);
		bool on_key_event(unsigned char key);
	public:
		Button(std::string const & name);
		Button(Widget * widget);
	};
	class CheckBox :
		virtual public Focusable
	{
		sigc::signal<void> toggled;
		bool active;
		void on_draw();
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
	protected:
		void on_button_event(int button, int state, int x, int y);
		bool on_key_event(unsigned char key);
		void draw_checkbox(int x, int y, int w, int h);
		static const int checkbox_size;
		static const int checkbox_area;
	public:
		CheckBox();
		sigc::signal<void> & signal_toggled();
		bool get_active() const;
		void set_active(bool val = true);
	};
	class CheckButton :
		virtual public CheckBox,
		virtual public LabelBin
	{
		int cb_width;
		void on_configure_event();
		void on_draw();
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		void get_preferred_width_for_height(int height, int & min, int & nat) const;
		void get_preferred_height_for_width(int width, int & min, int & nat) const;
		void on_button_event(int button, int state, int x, int y);
		bool on_key_event(unsigned char key);
		bool focus_make();
		bool focus_next();
		void focus_end();
	public:
		CheckButton(std::string const & label);
	};
	class Entry :
		public virtual Widget
	{
		std::string text;
		size_t max_length;
		bool focused;
		bool editable;
		bool visibility;
		size_t cursor;
		size_t vstart;
		size_t mark;
		bool marked;
		void * font;
		int width_chars;
		void on_draw();
		void on_button_event(int button, int state, int x, int y);
		void on_motion_event(int x, int y);
		bool on_key_event(unsigned char key);
		bool on_special_event(int key);
		bool focus_make();
		void focus_end();
		void adjust_vstart();
		int find_x(size_t p);
		size_t find_position(int x);
		void delete_marked();
		int bw;
		int as;
		bool end_arrow;
		sigc::signal<void> activate;
		sigc::signal<void> stop;
	public:
		Entry();
		void get_preferred_height(int & min, int & nat) const;
		void get_preferred_width(int & min, int & nat) const;
		void set_text(std::string const &);
		std::string const & get_text() const;
		size_t get_text_length() const;
		void select_all();
		void select_none();
		void set_max_length(size_t length);
		void set_width_chars(int n_chars);
		void set_editable(bool v = true);
		void set_visibility(bool v = true);
		sigc::signal<void> & signal_activate();
		sigc::signal<void> & signal_stop();
	};
	class glutWindow
	{
		friend class _glutWindow;
		int win_id;
		unsigned event_mask;
	protected:
		virtual void on_display_func() {}
		virtual void on_reshape_func(int width, int height) {}
		virtual void on_mouse_func(int button, int state, int x, int y) {}
		virtual void on_motion_func(int x, int y) {}
		virtual void on_passive_func(int x, int y) {}
		virtual void on_keyboard_func(unsigned char key, int x, int y) {}
		virtual void on_special_func(int key, int x, int y) {}
		virtual void on_entry_func(int state) {}
		enum EventMask {
			EVENT_MASK_NONE = 0,
			DISPLAY_MASK = 1 << 0,
			RESHAPE_MASK = 1 << 1,
			MOUSE_MASK = 1 << 2,
			MOTION_MASK = 1 << 3,
			PASSIVE_MASK = 1 << 4,
			KEYBOARD_MASK = 1 << 5,
			SPECIAL_MASK = 1 << 6,
			ENTRY_MASK = 1 << 7,
			EVENT_MASK_ALL = (1 << 8) - 1
		};
		virtual void on_create() {}
		virtual void on_destroy() {}
		glutWindow();
		virtual ~glutWindow();
		void set_events(unsigned mask);
		void add_events(unsigned mask);
		void create(int parent_win_id, int x, int y, int width, int height);
		void create(std::string const & name, int width, int height);
		void destroy();
		void destroy_all();
		int get_win_id() const {return win_id;}
		void set_current();
		void move(int x, int y);
		void resize(int width, int height);
		void redisplay();
	};
	class glArea :
		public glutWindow,
		public Widget
	{
		void on_display_func();
		void on_reshape_func(int width, int height);
		void on_draw();
		void on_unrealize() ;
		void on_configure_event() ;
		void on_show() ;
		void on_hide() ;
		int area_width;
		int area_height;
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		void make_realized();
	protected:
		virtual void gl_setup() {}
		virtual void gl_new_size(int w, int h) {}
		virtual void gl_draw() {}
		virtual void gl_button_event(int button, int state, int x, int y) {}
		virtual void gl_motion_event(int x, int y) {}
	public:
		glArea();
		~glArea();
		void set_size(int width, int height);
	};
	class SignalIdle
	{
	public:
		static sigc::connection connect(sigc::slot0<bool> const & slot);
		static void connect_once(sigc::slot0<void> const & slot);
	};
	class Label :
		virtual public Widget
	{
		std::string text;
		void * font;
		void on_draw();
		void get_preferred_height(int & min, int & nat) const;
		void get_preferred_width(int & min, int & nat) const;
	public:
		Label();
		Label(std::string const & label);
		void set_text(std::string const & text);
		std::string const & get_text() const {return text;}
		void * get_font() const {return font;}
	};
	class Window :
		glutWindow,
		public virtual Bin
	{
		static size_t visible_count;
		bool visible;
		void on_display_func();
		void on_reshape_func(int width, int height);
		void on_mouse_func(int button, int state, int x, int y);
		void on_motion_func(int x, int y);
		void on_passive_func(int x, int y);
		void on_keyboard_func(unsigned char key, int x, int y);
		void on_special_func(int key, int x, int y);
		void on_create();
		void on_destroy();
		bool get_focus();
		int default_w;
		int default_h;
		std::string title;
		int win_width;
		int win_height;
	public:
		Window();
		~Window();
		void set_default_size(int w, int h);
		void set_title(std::string const & title);
		void resize(int width, int height);
		void refresh();
		void show();
		void hide();
	};
	class Main
	{
	public:
		Main(int & argc, char * * (& argv));
		static void run(Window &);
	};
	class Scale :
		public virtual Widget
	{
		Adjustment * adjust;
		void on_draw();
		void on_button_event(int button, int state, int x, int y);
		void on_motion_event(int x, int y);
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		int slider_y0;
		int slider_sz;
		bool sliding;
		int sliding_start;
		double sliding_vs;
	public:
		Scale(Adjustment * adjust = 0);
		Adjustment * get_adjustment();
		void set_value(double value);
		double get_value() const;
		sigc::signal<void> & signal_value_changed();
	};
	class Shape :
		public virtual Widget
	{
	public:
		enum Predefined {
			UP_TRIANGLE,
			DOWN_TRIANGLE
		};
	private:
		void on_draw();
		void get_preferred_width(int & minimum, int & natural) const;
		void get_preferred_height(int & minimum, int & natural) const;
		Predefined shape;
		int width;
		int height;
	public:
		Shape(
			Predefined shape,
			int width,
			int height
		);
	};
	class SpinButton :
		virtual public Container,
		virtual public Adjustment
	{
		Entry tx;
		Button up;
		Button dn;
		void on_configure_event();
		void on_draw();
		void on_value_changed();
		void on_button_event(int button, int state, int x, int y);
		bool on_special_event(int key);
		void value_enter();
		void value_stop();
		unsigned spin_wait;
		unsigned spin_interval;
		double climb_value;
		bool held;
		sigc::connection held_timeout;
		bool spinning;
		bool button_held();
		void pushed_up();
		void pushed_dn();
	protected:
		double climb_rate;
		unsigned digits;
		bool snap_to_ticks;
		bool wrap;
	public:
		SpinButton(
			double climb_rate = 0.0,
			unsigned digits = 0
		);
		void get_preferred_width(int & min, int & nat) const;
		void get_preferred_height(int & min, int & nat) const;
		int get_value_as_int() const;
		unsigned get_digits() const;
		void set_digits(unsigned digits);
		void set_snap_to_ticks(bool snap_to_ticks);
		void set_increments(double step, double page);
		void set_range(double min, double max);
		void set_wrap(bool wrap = true);
		void set_width_chars(int n_chars);
	};
	class SignalTimeout
	{
	public:
		static sigc::connection connect(
			sigc::slot0<bool> const & slot,
			unsigned interval
		);
		static void connect_once(sigc::slot0<void> const & slot, unsigned interval);
	};
}
#endif
